var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-10CDD63C-79C1-4F2D-BB28-AD2BE65A02ED\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Computing Transformation Matrices</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-10CDD63C-79C1-4F2D-BB28-AD2BE65A02ED\"></a><div class=\"head\">\n            <h1>Computing Transformation Matrices</h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF3913A1A412260CA5929-74C1\"></a>The FBX SDK and Maya use the same formula to compute a transformation matrix. However,\n            3ds Max uses a different formula. \n         </p>\n         <div><a name=\"WS1A9193826455F5FF1F92379812724681E697361\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The FBX importers and exporters for 3ds Max automatically convert transformation matrices\n               to and from 3ds Max. \n            </div>\n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF1F92379812724681E697362\"></a> \n            <h2><a name=\"GUID-703FB5DF-9F0C-400E-9954-596019B90EA9\"></a>FBX and Maya\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF1F92379812724681E697363\"></a>The following formula represents how the FBX SDK and Maya compute the transformation\n               matrix for a node: \n            </p> \n            <p><a name=\"WS1A9193826455F5FF1F92379812724681E697364\"></a> <span class=\"code\">WorldTransform&nbsp;= ParentWorldTransform * T * Roff * Rp * Rpre * R * Rpost<span class=\"charspan-emphasis\"> <sup>-1</sup> </span> * Rp<sup> <span class=\"charspan-emphasis\">-1</span> </sup> * Soff * Sp * S * Sp<sup> <span class=\"charspan-emphasis\">-1</span> </sup></span> \n            </p> \n            <p><a name=\"GUID-711E4498-A916-4CD6-8C8D-5263D20CDFD6\"></a>Any given vector is transformed so that <span class=\"code\">V<sup>\'</sup> = WorldTransform * V</span>. \n            </p> <a name=\"WS1A9193826455F5FF3913A1A412260CA5929-74BF\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"50%\">\n                     <col width=\"50%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Where the term: </th>\n                     <th class=\"table-heading\">Is a 4 x 4 matrix that contains: </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">WorldTransform</span> \n                     </td>\n                     <td class=\"table-body\">Transformation matrix of the node </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">ParentWorldTransform</span> \n                     </td>\n                     <td class=\"table-body\">Transformation matrix of the parent node </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">T</span> \n                     </td>\n                     <td class=\"table-body\">Translation </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">Roff</span> \n                     </td>\n                     <td class=\"table-body\">Rotation offset </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">Rp</span> \n                     </td>\n                     <td class=\"table-body\">Rotation pivot </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">Rpre</span> \n                     </td>\n                     <td class=\"table-body\">Pre-rotation </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">R</span> \n                     </td>\n                     <td class=\"table-body\">Rotation </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">Rpost<span class=\"charspan-emphasis\"> <sup>-1</sup> </span></span> \n                     </td>\n                     <td class=\"table-body\">Inverse of the post-rotation </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF3913A1A412260CA5929-74BE\"></a><p class=\"table-body\"> <span class=\"code\">Rp</span> <sup> <span class=\"charspan-emphasis\">-1</span> </sup> \n                        </p> \n                     </td>\n                     <td class=\"table-body\">Inverse of the rotation pivot </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">Soff</span> \n                     </td>\n                     <td class=\"table-body\">Scaling offset </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">Sp</span> \n                     </td>\n                     <td class=\"table-body\">Scaling pivot </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">S</span> \n                     </td>\n                     <td class=\"table-body\">Scaling </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF3913A1A412260CA5929-74BD\"></a><p class=\"table-body\"> <span class=\"code\">Sp</span> <sup> <span class=\"charspan-emphasis\">-1</span> </sup> \n                        </p> \n                     </td>\n                     <td class=\"table-body\">Inverse of the scaling pivot </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-570A\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-5709\"></a>Notes:\n            </p>\n            <ul>\n               <li>The effect of the formula is that any given vector is first scaled, then rotated,\n                  and finally translated. \n               </li>\n               <li>The <span class=\"code\">R</span> matrix takes into account the <em class=\"mild\">rotation order</em>. Because of the mathematical properties of the matrices, <span class=\"code\">R</span> is the result of one of the possible combinations of <span class=\"code\">Rx</span>, <span class=\"code\">Ry</span>, and <span class=\"code\">Rz</span> (each being matrices). For example, for the default rotation order of XYZ, <span class=\"code\">R = Rz * Ry * Rx</span>. \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF1F92379812724681E697366\"></a> \n            <h2><a name=\"GUID-1D2BF5B9-A730-4045-91F1-DA477A5E7CB8\"></a>3ds Max\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF1F92379812724681E697367\"></a>The following formula represents how 3ds Max computes the transformation matrix for\n               a node. All the terms in the formula are the same as in FBX and Maya, except for the\n               three terms that represent geometric transformation: \n            </p> \n            <p><a name=\"WS1A9193826455F5FF1F92379812724681E697368\"></a> <span class=\"code\">WorldTransform&nbsp;= ParentWorldTransform * T * R * S * OT * OR * OS</span> \n            </p> <a name=\"WS1A9193826455F5FF1F92379812724681E697369\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"50%\">\n                     <col width=\"50%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Where the term: </th>\n                     <th class=\"table-heading\">Is a 4 x 4 matrix that contains: </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">WorldTransform</span> \n                     </td>\n                     <td class=\"table-body\">Transformation matrix of the node </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">ParentWorldTransform</span> \n                     </td>\n                     <td class=\"table-body\">Transformation matrix of the parent node </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">T</span> \n                     </td>\n                     <td class=\"table-body\">Translation </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">R</span> \n                     </td>\n                     <td class=\"table-body\">Rotation </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">S</span> \n                     </td>\n                     <td class=\"table-body\">Scaling </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">OT</span> \n                     </td>\n                     <td class=\"table-body\">Geometric transform translation </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">OR</span> \n                     </td>\n                     <td class=\"table-body\">Geometric transform rotation </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">OS</span> \n                     </td>\n                     <td class=\"table-body\">Geometric transform scaling </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS1A9193826455F5FF1F92379812724681E69736A\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF1F92379812724681E69736B\"></a>Notes:\n            </p>\n            <ul>\n               <li>Geometric translation, geometric rotation, and geometric scaling relate to the object-offset\n                  concept in 3ds Max. These geometric transformations are applied to the node attribute\n                  after the node transformations. \n               </li>\n               <li>Geometric transformations are not inherited: <span class=\"code\">ParentWorldTransform</span> does not contain the OT, OR, and OS of <span class=\"code\">WorldTransform</span>’s parent node. \n               </li>\n               <li>Geometric transformations are implemented in the FBX SDK as three properties of the\n                  <span class=\"code\">FbxNode</span> object: <span class=\"code\">FbxNode::GeometricTranslation</span>, <span class=\"code\">FbxNode::GeometricRotation</span>, and <span class=\"code\">FbxNode::GeometricScaling</span>. \n               </li>\n            </ul> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";