var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-19B34654-ADBB-43D6-915A-8EF3B3579A1A\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>FBX SDK 2012</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-19B34654-ADBB-43D6-915A-8EF3B3579A1A\"></a><div class=\"head\">\n            <h1>FBX SDK 2012 </h1>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_D170052EFD3346968FF07162BD1CBFBE\"></a> \n            <h2><a name=\"GUID-F0683C4C-D002-46D3-8A18-E2DB50AF1341\"></a>Windows Platform Packaging\n            </h2> \n            <p><a name=\"GUID-6DFAAB53-4AF7-4A60-B102-4AAF0046D0F5\"></a> <a name=\"UL_6589EFDBDC524562BA93383F05B8530D\"></a><ul>\n                  <li>The packaging of the FBX SDK for the Microsoft Windows platform has changed to reduce\n                     the size of the download. \n                  </li>\n                  <li>The preprocessor identifier that must be defined when linking with the dynamic library\n                     version of the FBX SDK has changed from <span class=\"code\">KFBX_DLLINFO</span> to <span class=\"code\">FBXSDK_SHARED</span>. <span class=\"code\">KFBX_DLLINFO</span> now serves no purpose. For statically linked library versions of the FBX SDK, no\n                     preprocessor identifiers must be defined. \n                  </li>\n                  <li>Static libraries are now built with <span class=\"code\">_SECURE_SCL=1</span>, which is the default value in Visual Studio projects. If your project used to define\n                     <span class=\"code\">_SECURE_SCL=0</span> to link with previous versions of the FBX SDK, it can now safely be removed from\n                     the predefined preprocessor identifiers. \n                  </li>\n                  <li>All FBX-related DLL\'s are now officially signed with the Autodesk certificate. </li>\n                  <li>For more information, see <span class=\"char_link\"><a href=\"GUID-063B70C4-CADC-42B5-9DCC-55274A8B0837.htm\">Installing and Configuring</a></span>. \n                  </li>\n               </ul> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_458E1A4AED584B9FA3C0C7D006374664\"></a> \n            <h2><a name=\"GUID-AB367523-276D-4B0D-BC0E-1EAFA6AEE9F4\"></a>File Format Version 7.2. \n            </h2> \n            <p><a name=\"GUID-7494774B-E854-4D8F-969D-E7EF9C48820E\"></a> <a name=\"UL_A3CB3A785AED49608C17100E4FBBD299\"></a><ul>\n                  <li>The file format version of FBX files has been incremented to 7.2. There have been\n                     various small changes in the file format to support new data. The new header file\n                     <span class=\"filePath\">fbxfilesdk_version.h</span> defines the preprocessor identifer <span class=\"code\">FBXSDK_VERSION_STRING</span>, which represents the version information as a string (see <span class=\"char_link\"><a href=\"GUID-ABFC58F1-C10D-42AE-A204-D79EB1D84B24.htm\">Importing a Scene</a></span>). \n                  </li>\n               </ul> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_D119EE758B3445A580DF2601315AD417\"></a> \n            <h2><a name=\"GUID-37B04DEE-7BBD-4E28-B967-9293E49DB711\"></a>Texture Changes\n            </h2> \n            <p><a name=\"GUID-E6014E99-35E8-429E-8A26-E4BBCDDE39AF\"></a> <a name=\"UL_818570FBE7414D6496C4BE2C6B8488ED\"></a><ul>\n                  <li>Support for Allegorithmic\'s Substance (procedural textures) has been added to the\n                     FBX SDK core. The <span class=\"code\">KFbxTexture</span> class serves as the base class for <span class=\"code\">KFbxFileTexture</span>, <span class=\"code\">KFbxLayeredTexture</span>, and <span class=\"code\">KFbxProceduralTexture</span>. <span class=\"code\">KFbxFileTexture</span> should now be used for bitmap textures, replacing <span class=\"code\">KFbxTexture</span>. \n                  </li>\n                  <li>Roughly 25 new texture blend modes were added. The default blend mode is now Normal\n                     instead of Translucent. These texture blend modes can be found in <span class=\"code\">KFbxTexture::EBlendMode</span> \n                  </li>\n                  <li>Ptex files can be transported just like any other texture format (png, jpeg, etc.),\n                     provided they are connected to a material property. For more information about Ptex,\n                     visit <a href=\"http://ptex.us/documentation.html\" target=\"_blank\">http://ptex.us/documentation.html</a>. \n                  </li>\n               </ul> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_244B83D6336A475592F0BE34E936E7AD\"></a> \n            <h2><a name=\"GUID-FDC1A450-E6CE-4A69-9F7F-0F4C33608644\"></a>Evaluation and Animation Changes\n            </h2> \n            <p><a name=\"GUID-51BB52BA-AAC2-4F4D-99D2-58B38CEF57B4\"></a> <a name=\"UL_D02F662F4D88459687607C868686337E\"></a><ul>\n                  <li>New quaternion evaluation modes for rotation animation curves are now available, equivalent\n                     to those found in Autodesk Maya. See <span class=\"code\">KFbxAnimCurveNode::SetQuaternionInterpolation</span>. \n                  </li>\n                  <li>Support for Dual Quaternion Skinning has been added. See <span class=\"code\">KFbxDualQuaternion</span> for more information. \n                  </li>\n                  <li>A new type of animation curve has been added to the FBX SDK core to allow better support\n                     of Autodesk 3dsMax \"auto\" keys with crease in/out. See the tangent and interpolation\n                     modes in <span class=\"code\">KFbxAnimCurve</span>. \n                  </li>\n                  <li>Added five new matrix transform evaluation functions to the <span class=\"code\">KFbxNode</span> class for convenience. These functions are equivalent to calling <span class=\"code\">KFbxScene-&gt;GetEvaluator()-&gt;...</span>: <a name=\"UL_95BBAB80B6504D4DA10B2626D88854B1\"></a><ul>\n                        <li> <span class=\"code\">KFbxNode::EvaluateGlobalTransform()</span> \n                        </li>\n                        <li> <span class=\"code\">KFbxNode::EvaluateLocalTransform()</span> \n                        </li>\n                        <li> <span class=\"code\">KFbxNode::EvaluateLocalTranslation()</span> \n                        </li>\n                        <li> <span class=\"code\">KFbxNode::EvaluateLocalRotation()</span> \n                        </li>\n                        <li> <span class=\"code\">KFbxNode::EvaluateLocalScaling()</span> \n                        </li>\n                     </ul> \n                  </li>\n                  <li>Added the <span class=\"code\">KFbxEvaluator::ResetEvaluationState()</span> function to enable users to completely clear the whole evaluation cache by deleting\n                     all entries in it. \n                  </li>\n               </ul> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_B04F20B332E049DB95F47D73AC247448\"></a> \n            <h2><a name=\"GUID-D2966CB5-B04C-4E16-AA3C-CBC32A4199BB\"></a>Import/Export Changes\n            </h2> \n            <p><a name=\"GUID-2577B30D-7F95-4E58-A414-727FFA06959E\"></a> <a name=\"UL_5417E7949CD94E25AF735C7C1118E818\"></a><ul>\n                  <li>Many improvements to the import time of FBX files have been made. </li>\n                  <li>The memory footprint of FBX files has been reduced. </li>\n                  <li>The Collada importer now supports the Collada 1.4.1. standard. </li>\n                  <li>Support for \"in-between\" blend shapes has been added in the FBX SDK core to allow\n                     application plug-ins to import/export these states. See <span class=\"code\">KFbxBlendShape</span>, and <span class=\"code\">KFbxShape</span>. \n                  </li>\n                  <li>Object names will now appear in ASCII FBX files as comments in the connection section\n                     for easier debugging. \n                  </li>\n                  <li>Added the <span class=\"code\">KFbxImporter::SetEmbeddingExtractionFolder()</span> function to allow developers to specify an extraction folder when importing FBX files.\n                     \n                  </li>\n               </ul> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_CA24404303854ADBA742A3F863966E64\"></a> \n            <h2><a name=\"GUID-C93A113E-09CE-4838-B2CC-8813AB30FCA4\"></a>Other Changes\n            </h2> \n            <p><a name=\"GUID-C5F813EA-A41E-417B-B25C-1F84348FD47D\"></a> <a name=\"UL_982D488EDD9249F9A1D4F8DDA9C27A61\"></a><ul>\n                  <li>The <span class=\"code\">KFbxCharacter</span> class has been improved to benefit the interoperability of character data with other\n                     Autodesk 3D applications. \n                  </li>\n                  <li>Support for vector displacement maps has been added. See <span class=\"code\">KFbxSurfaceMaterialLambert::VectorDisplacementColor</span> and <span class=\"code\">KFbxSurfaceMaterialLambert::VectorDisplacementFactor</span>. \n                  </li>\n                  <li>The visibility inheritance behavior of scene nodes have changed to better align with\n                     popular Autodesk 3D applications. \n                  </li>\n                  <li>Added support for line geometry in the <span class=\"code\">KFbxLine</span> class. \n                  </li>\n                  <li>Added an option to <span class=\"code\">KMemoryPool</span> to control concurrent allocations. Previously, the allocation was always in concurrent\n                     mode. \n                  </li>\n                  <li>The FBX SDK is now built with full optimization settings (i.e. both size and speed),\n                     instead of being optimized for speed only. \n                  </li>\n                  <li>A new tesselation function was added to NURB curves to provide a work-around for applications\n                     that do not support them. The tesselation will produce a <span class=\"code\">KFbxLine</span> object (a series of vertices). See <span class=\"code\">KFbxNurbsCurve::TessellateCurve()</span>. \n                  </li>\n                  <li>Added new functions to the <span class=\"code\">KFbxCache</span> class: <a name=\"UL_8B6A6654D9094F86906B5264816850A2\"></a><ul>\n                        <li> <span class=\"code\">KFbxCache::GetNextTimeWithData()</span> \n                        </li>\n                        <li> <span class=\"code\">KFbxCache::GetDataCount()</span> \n                        </li>\n                        <li> <span class=\"code\">KFbxCache::GetDataTime()</span> \n                        </li>\n                     </ul> \n                  </li>\n               </ul> \n            </p> \n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-8EA6A733-8B78-4698-85A7-F19F426E9DD1.htm\">2012.2</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-08159356-B8CA-42D2-82F3-954409C41A8F.htm\">2012.1</a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";