var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-274163DA-9E89-4DCC-8AF6-10B0C498582E\">\n      <meta name=\"description\" content=\"This topic provides a broad description of Autodesk FBX technology and its features.\">\n      <meta name=\"indexterm\" content=\"Autodesk FBX technology, about\">\n      <meta name=\"indexterm\" content=\"FBX: technology\">\n      <meta name=\"indexterm\" content=\"technology, FBX\">\n      <meta name=\"indexterm\" content=\"FBX: file formats for 3D scenes\">\n      <meta name=\"indexterm\" content=\"3D scenes, FBX file formats for\">\n      <meta name=\"indexterm\" content=\"file formats: FBX for 3D scenes\">\n      <meta name=\"indexterm\" content=\"FBX SDK: about\">\n      <meta name=\"indexterm\" content=\"nopage: SDK, FBX. See FBX SDK\">\n      <meta name=\"indexterm\" content=\"nopage: Software Development Kit. See FBX SDK\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>What is Autodesk FBX Technology?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-274163DA-9E89-4DCC-8AF6-10B0C498582E\"></a><div class=\"head\">\n            <h1>What is Autodesk FBX Technology?</h1>\n         </div>\n         <p class=\"blurb\">This topic provides a broad description of Autodesk FBX technology and its features.\n            \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C6E\"></a>  The FBX SDK is part of Autodesk FBX technology, a family of tools which allow 3D\n            content developers to import and export 3D data. Autodesk FBX contributes to the flexibility\n            of organizations involved in the media and entertainment industry by allowing them\n            to mix and match a variety of 2D and 3D digital content creation applications. \n         </p>\n         <div class=\"section\"><a name=\"WS8E4C2438B09B7F9C-1C1791801197CCD8A5F-7FFF\"></a> \n            <h2><a name=\"GUID-8347EA6F-DDD9-401B-8EE7-203680288363\"></a>FBX File Format for 3D Scenes\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C62\"></a> FBX files (<em class=\"mild\">.fbx</em>) are normally saved in a binary (or native) format, but they can also be saved in\n               ASCII format. Binary FBX files and ASCII FBX files both use the&nbsp; <em class=\"mild\">.fbx</em> filename extension. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-3859B43C1209703A8387C97\"></a>FBX files store data about cameras, lights, meshes, NURBS, and the other <em class=\"mild\">elements</em> of a 3D scene. Applications such as Autodesk 3ds Max, Autodesk Maya, and Autodesk\n               MotionBuilder can import all or part of the scene data from an FBX file. They can\n               also export their scene data to an FBX file. All these operations make use of the\n               FBX SDK. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C60\"></a>Here is an shortened version of a small FBX file in ASCII format. Omitted lines are\n               indicated by <span class=\"code\">...</span>, and we have manually added some comments. Comments begin with a semicolon (“<span class=\"code\">;</span>“) anywhere on a line. \n            </p> \n            <div class=\"codeBlock\"><pre>\n; FBX 7.1.0 project file\n; Copyright (C) 1997-2010 Autodesk Inc. and/or its licensors.\n; All rights reserved.\n; ----------------------------------------------------\nFBXHeaderExtension:  {\n&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;; header information: global file information.\n    FBXHeaderVersion: 1003\n    FBXVersion: 7100\n    CreationTimeStamp:  {\n        Version: 1000\n        Year: 2010\n        Month: 1\n        Day: 19\n        Hour: 16\n        Minute: 30\n        Second: 28\n        Millisecond: 884\n    }\n    Creator: \"FBX SDK/FBX Plugins version 2011.2\"\n    SceneInfo: \"SceneInfo::GlobalInfo\", \"UserData\" {\n ...\n}\nGlobalSettings:  {\n    Version: 1000\n    Properties70:  {\n        P: \"UpAxis\", \"int\", \"Integer\", \"\",1\n        P: \"UpAxisSign\", \"int\", \"Integer\", \"\",1\n        P: \"FrontAxis\", \"int\", \"Integer\", \"\",2\n        P: \"FrontAxisSign\", \"int\", \"Integer\", \"\",1\n        P: \"CoordAxis\", \"int\", \"Integer\", \"\",0\n        P: \"CoordAxisSign\", \"int\", \"Integer\", \"\",1\n        P: \"OriginalUpAxis\", \"int\", \"Integer\", \"\",-1\n        P: \"OriginalUpAxisSign\", \"int\", \"Integer\", \"\",1\n        P: \"UnitScaleFactor\", \"double\", \"Number\", \"\",1\n        P: \"OriginalUnitScaleFactor\", \"double\", \"Number\", \"\",1\n        P: \"AmbientColor\", \"ColorRGB\", \"Color\", \"\",0,0,0\n        P: \"DefaultCamera\", \"KString\", \"\", \"\", \"Producer Perspective\"\n        P: \"TimeMode\", \"enum\", \"\", \"\",6\n        P: \"TimeSpanStart\", \"KTime\", \"Time\", \"\",0\n        P: \"TimeSpanStop\", \"KTime\", \"Time\", \"\",46186158000\n    }\n}\n ...\n; Object definitions\n;------------------------------------------------------------------\nDefinitions:  {\n    Version: 100\n    Count: 2251\n    ObjectType: \"GlobalSettings\" {\n        Count: 1\n    }\n    ObjectType: \"Model\" {\n        Count: 86\n        PropertyTemplate: \"FbxNode\" {\n            Properties70:  {\n                P: \"QuaternionInterpolate\", \"bool\", \"\", \"\",0\n                P: \"RotationOffset\", \"Vector3D\", \"Vector\", \"\",0,0,0\n                P: \"RotationPivot\", \"Vector3D\", \"Vector\", \"\",0,0,0\n                P: \"ScalingOffset\", \"Vector3D\", \"Vector\", \"\",0,0,0\n                P: \"ScalingPivot\", \"Vector3D\", \"Vector\", \"\",0,0,0\n ...}\n    ObjectType: \"Material\" {\n        Count: 1\n        PropertyTemplate: \"FbxSurfacePhong\" {\n            Properties70:  {\n                P: \"ShadingModel\", \"KString\", \"\", \"\", \"Phong\"\n                P: \"MultiLayer\", \"bool\", \"\", \"\",0\n                P: \"EmissiveColor\", \"ColorRGB\", \"Color\", \"\",0,0,0\n                P: \"EmissiveFactor\", \"double\", \"Number\", \"\",1\n                P: \"AmbientColor\", \"ColorRGB\", \"Color\", \"\",0.2,0.2,0.2\n ...}\n    Model: 21883936, \"Model::Humanoid:Hips\", \"LimbNode\" {\n        Version: 232\n        Properties70:  {\n            P: \"ScalingMin\", \"Vector3D\", \"Vector\", \"\",1,1,1\n            P: \"NegativePercentShapeSupport\", \"bool\", \"\", \"\",0\n            P: \"DefaultAttributeIndex\", \"int\", \"Integer\", \"\",0\n            P: \"Lcl Translation\", \"Lcl Translation\", \"\", \"A+\",-271.281097412109,-762.185852050781,528.336242675781\n            P: \"Lcl Rotation\", \"Lcl Rotation\", \"\", \"A+\",-1.35128843784332,2.6148145198822,0.42334708571434\n            P: \"Lcl Scaling\", \"Lcl Scaling\", \"\", \"A+\",1,0.99999988079071,1\n ...\n</pre></div> \n            <div><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C5E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span><em class=\"strong\">The FBX file format is not documented</em>. Applications should use the FBX SDK to export and import scene data to and from\n                  FBX files (and other file formats supported by the FBX SDK). \n               </div>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS8E4C2438B09B7F9C-1C1791801197CCD8A5F-7FFB\"></a> \n            <h2><a name=\"GUID-ADAFD53F-E980-4840-B7E9-6F9B8FB0D37E\"></a>FBX Software Development Kit\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C4F\"></a> The FBX Software Development Kit (FBX SDK) allows software developers to create applications\n               that use FBX technology, or to integrate FBX technology into their existing applications.\n               \n            </p> \n            <p><a name=\"GUID-81190A37-C481-4249-996C-4D990F76781A\"></a>Note that the FBX SDK is not covered by the GNU General Public License (GPL), and\n               the source code is not publicly available. Some source code does exists for customizing\n               the Maya and 3ds Max FBX plug-ins, though it is packaged in the FBX Extensions SDK,\n               and not in the FBX SDK itself. The latest release and any previous version of the\n               FBX SDK can be obtained on the Autodesk FBX website at <a href=\"http://www.autodesk.com/fbx\" target=\"_blank\">http://www.autodesk.com/fbx</a>.The FBX SDK cannot be redistributed or repackaged without written permission from\n               Autodesk. Should you wish to distribute an open-source project which uses the FBX\n               SDK, you must include a link to the Autodesk FBX website so the user may install the\n               required version of the FBX SDK. \n            </p> \n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-E16AA044-30EC-4625-A7C0-2FC2F36F4B1F.htm\">Sample FBX Applications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-F8D00075-A916-4AE2-AD7E-ED9DA2E5CF2C.htm\">Where FBX Fits in the Creation Pipeline</a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";