var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-363E55D8-6EDB-40F8-8F58-E42F8D525D3D\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Differences between FBX SDK and Python FBX</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-363E55D8-6EDB-40F8-8F58-E42F8D525D3D\"></a><div class=\"head\">\n            <h1>Differences between FBX SDK and Python FBX</h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-751DE9951262947C01C-41CA\"></a>Python FBX contains most of the classes and member functions that are available in\n            FBX SDK itself. Here are the important differences: \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-751DE9951262947C01C-41C9\"></a> \n            <h2><a name=\"GUID-D61D5914-7D69-4E47-B77B-6BB23111AD86\"></a>Function templates and class templates not provided\n            </h2> \n            <p><a name=\"WS73099CC142F48755-751DE9951262947C01C-41C8\"></a>C++ supports <em class=\"mild\">function templates</em>. These are functions for which the type of data on which the function operates can\n               be specified as a parameter. <em class=\"mild\">Class templates</em> are classes whose member functions can be function templates. \n            </p> \n            <p><a name=\"WS73099CC142F48755-751DE9951262947C01C-41C7\"></a>Python does not support templates. Accordingly, Python FBX cannot have classes and\n               functions that correspond to the C++ class templates and function templates. But Python\n               FBX does provide some support: \n            </p> <a name=\"WS1A9193826455F5FF453265C912632E09848-37E2\"></a><ul>\n               <li>FBX SDK has functions that are <em class=\"mild\">overloaded</em> (i.e, there are various versions of the function that share the same function name).\n                  In some cases (e.g., <span class=\"code\">FbxProperty::DisconnectAllSrcObjects</span>), some of the overloaded functions are template functions, while others are ordinary\n                  functions. In these cases, Python FBX does provide the ordinary functions. \n               </li>\n               <li>For each template function in FBX SDK, Python FBX provides a Python version that accepts\n                  <span class=\"code\">double</span> parameters and/or returns a <span class=\"code\">double</span> return value. That allows you to also use a <span class=\"code\">float</span>, <span class=\"code\">int</span>, or any other Python data type that can be converted to a <span class=\"code\">double</span>. \n               </li>\n               <li>For each template function in FBX SDK, Python FBX does provide a version that accepts\n                  <span class=\"code\">str</span> parameters and/or returns a <span class=\"code\">str</span> return value. \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-751DE9951262947C01C-41BC\"></a> \n            <h2><a name=\"GUID-46253D53-525B-4887-98B9-11C4FA8943A7\"></a>An array in C++ becomes a list in Python\n            </h2> \n            <p><a name=\"WS73099CC142F48755-751DE9951262947C01C-41BB\"></a>In C++, a pointer variable is sometimes used to pass an array as a parameter, or to\n               return an array as a return value. For example, in this C++ function, <span class=\"code\">int*</span> (a pointer to an integer) actually refers to an array of integers: \n            </p> \n            <div class=\"codeBlock\"><pre>\nint* FbxMesh::GetPolygonVertices();\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-751DE9951262947C01C-41BA\"></a>In FBX Python, this array of integers is converted to a <span class=\"code\">list</span> of type <span class=\"code\">int</span>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-2B37\"></a> \n            <h2><a name=\"GUID-0CFD057E-CF8B-494F-9013-BC4F4BD55ABD\"></a>Call by reference becomes an extra return value\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-2B36\"></a>In C++, a pointer variable (e.g., <span class=\"code\">int *pLast</span> is sometimes used with a simple type (such as <span class=\"code\">int</span>, <span class=\"code\">float</span>, <span class=\"code\">double</span>) to support call-by-reference. A call-by-reference parameter allow programmers to\n               not only pass a value to a function, but also to return the new value for the parameter\n               (if the function changes it). \n            </p> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-2B35\"></a>In Python, call-by-reference is not supported. But Python does support functions returning\n               <em class=\"mild\">tuples</em> (i.e., two return values). C++ does not support tuples as return values. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-2B34\"></a> <span class=\"code\">FbxAnimCurve::KeyAdd</span> is an example of how Python FBX uses tuples as a replacement for call-by-reference.\n               In the C++ version of FBX SDK, the signature for <span class=\"code\">FbxAnimCurve::KeyAdd</span> looks like this: \n            </p> \n            <div class=\"codeBlock\"><pre>\nint KeyAdd(FbxTime pTime, int *pLast);\n</pre></div> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-2B32\"></a>For this function, <span class=\"code\">int&nbsp;*pLast</span> is used only to return a value from the function, not to pass a value to it. For\n               the Python FBX, the signature has been converted to this: \n            </p> \n            <div class=\"codeBlock\"><pre>\n(int, int) KeyAdd(FbxTime pTime);\n</pre></div> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-2B31\"></a>Python FBX has converted <span class=\"code\">int&nbsp;*pLast</span> to a second <span class=\"code\">int</span> return value. \n            </p> \n            <p><a name=\"WS73099CC142F487552B5AC6C412649166E6E-1BDA\"></a>Let’s consider an imaginary C++ function where a pointer variable is used both to\n               pass a value and to return a value: \n            </p> \n            <div class=\"codeBlock\"><pre>\nint imaginaryFunction(int *myParameter);\n</pre></div> \n            <p><a name=\"WS73099CC142F487552B5AC6C412649166E6E-1BD9\"></a>For Python, the signature would be converted to this: \n            </p> \n            <div class=\"codeBlock\"><pre>\n(int, int) imaginaryFunction(int myParameter);\n</pre></div> \n            <p><a name=\"WS73099CC142F487552B5AC6C412649166E6E-1BD8\"></a>In this case, Python FBX makes two changes. It converted <span class=\"code\">int&nbsp;*myParameter</span> to: \n            </p> <a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-2B30\"></a><ul>\n               <li> <span class=\"code\">int&nbsp;myParameter</span> (to pass an integer value into the function). \n               </li>\n               <li>The second <span class=\"code\">int</span> return value (to return the changed integer value<span class=\"code\">)</span>. \n               </li>\n            </ul> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";