var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-386BAD6A-82F9-4148-BD5F-3FE2E90A87D0\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Animation Classes and their Interrelationships</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-386BAD6A-82F9-4148-BD5F-3FE2E90A87D0\"></a><div class=\"head\">\n            <h1>Animation Classes and their Interrelationships</h1>\n         </div>\n         <p><a name=\"GUID-E6E376BB-088F-4BCB-B0C6-88D1F8CEDF82\"></a> Following are the classes that store animation-related data in a scene: <a name=\"TABLE_43F4D0171E4A45D1A22AA9D23DBAED1C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"25%\">\n                     <col width=\"75%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Class </th>\n                     <th class=\"table-heading\" align=\"center\">Description </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">FbxScene</span> \n                     </td>\n                     <td class=\"table-body\">A scene can contain one or more animation stacks. <a name=\"GUID-B95ED87A-7BC3-42AF-BA9C-352390FF02DD\"></a><p class=\"table-body\"> You do not need to use animation stacks or other animation classes if there is no\n                           animation in the scene. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">FbxAnimStack</span> \n                     </td>\n                     <td class=\"table-body\">The animation stack is the highest-level container for the animation data and contains\n                        one or more animation layers. \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">FbxAnimLayer</span> \n                     </td>\n                     <td class=\"table-body\">An animation layer contains one or more animation curve nodes that are connected to\n                        the animation curves. The animation stack must have at least one animation layer known\n                        as the base layer. For blended animation, more than one animation layer is required.\n                        \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">FbxAnimCurve</span> \n                     </td>\n                     <td class=\"table-body\">An animation curve, also known as function curve or FCurve defines how a FBX property\n                        (<span class=\"code\">FbxProperty</span>) of a FBX object is animated or different from the default value in the animation\n                        layer. The animation curves are connected to the animation curve nodes. The same animation\n                        curve can be connected to multiple animation curve nodes regardless of the referred\n                        FBX property. Accordingly, one animation curve can animate many FBX properties of\n                        many FBX objects. The values in the animation curves are dependent on the FBX property\n                        type and is validated by the application. <a name=\"GUID-B32D2EAB-1314-4FCA-9181-E9F3E360B102\"></a><p class=\"table-body\"> Animation curves are not mandatory. To save the memory and processing time, FBX properties\n                           that are not animated can be left without using the animation curves. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">FbxAnimCurveNode</span> \n                     </td>\n                     <td class=\"table-body\">An animation curve node (<span class=\"code\">FbxAnimCurveNode</span>) is the connection point between the animation curves and the FBX properties. To\n                        connect an animation curve to a FBX property, you can connect the animation curve\n                        and the FBX property to one animation curve node. <a name=\"GUID-D3BCDA4F-8AAF-4BC8-8D33-76DCE1045D57\"></a><p class=\"table-body\">An animation curve node can be connected to only one FBX property of one FBX object.\n                           FBX properties such as <span class=\"code\">FbxNode::LclTranslation</span> contain more than one value (X, Y, Z). If you create an animation curve node by calling\n                           <span class=\"code\">FbxAnimCurveNode::CreateTypedCurveNode</span>, you must specify a FBX property of the data type you need, for example, the function\n                           <span class=\"code\">CreateTypedCurveNode()</span> in <span class=\"code\">LclTranslation</span> creates an animation curve node with the necessary <em class=\"mild\">animation channels</em>. In this example, channels X, Y, and Z. However, the animation curve node is not\n                           actually connected to the specified FBX property. See the animation sample program\n                           in <span class=\"code\"><em class=\"mild\">&lt;yourFBXSDKpath&gt;</em>\\samples\\Animation\\</span>. \n                        </p> <a name=\"GUID-6645A46F-0D26-4733-BCF2-69384B4FDA44\"></a><p class=\"table-body\"> To allow the same FBX property to have different values on each animation layer,\n                           an animation curve node must be connected to a single animation layer. If the same\n                           animation curve node is connected to multiple animation layers, the same value is\n                           used for the FBX property in each of these animation layers. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">FbxAnimCurveKey</span> \n                     </td>\n                     <td class=\"table-body\"> A key or keyframe marks the beginning and the end of an animation curve. </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">FbxObject</span> \n                     </td>\n                     <td class=\"table-body\">A FBX object can contain zero or more FBX properties. Class <span class=\"code\">FbxNode</span> contains the properties that deal with the location of an object as a point in space.\n                        \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">FbxProperty</span> \n                     </td>\n                     <td class=\"table-body\"> A FBX property is strongly typed data that belongs to a FBX object. To animate a\n                        scene, you can set the appropriate FBX properties (<span class=\"code\">LclTranslation</span> is the most common) contained in the FBX objects. For more information, see <span class=\"char_link\"><a href=\"GUID-283ED424-E506-4A29-848F-9EAC8F1C4AF9.htm\">FBX Properties</a></span>. \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </p>\n         <p><a name=\"WS73099CC142F48755-13B8418F12724676A534303\"></a>The following UML class diagram shows the interrelationships of classes in a FBX scene.\n            \n         </p><a name=\"WS1A9193826455F5FF1F92379812724681E6971D9\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-76BCFC3B-AACF-4CF1-B8AF-5B56F7551DDA-low.png\"></div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-E7B43ABC-7F96-4A75-8769-3B7574F768AB.htm\">Scene Showing Interrelationships among Data Structures</a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";