var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-46861D48-8EFE-43DB-A0EA-2EE5AB6D441A\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>FBX Extensions to Maya</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-46861D48-8EFE-43DB-A0EA-2EE5AB6D441A\"></a><div class=\"head\">\n            <h1>FBX Extensions to Maya</h1>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_76BB4EB5B4F54650ABDCCA50BBAACCDC\"></a> \n            <h2><a name=\"GUID-92FC594D-F2EA-45AE-BBE2-574695B38455\"></a>Maya FBX Extension Interface\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF2566FFD511FDE75E656748B\"></a>FBX Extensions to the <em class=\"mild\">FBX Plug-in</em> for Maya can implement any or all of the following functions. Note that the <span class=\"code\">MObject</span> class refers to the <a href=\"http://www.autodesk.com/maya-sdkdoc-2012-enu\" target=\"_blank\">Maya SDK</a>. \n            </p> \n            <div class=\"codeBlock\"><pre>EXPORT_DLL bool MayaExt_IsExtension(){return true;}\n&nbsp;\nEXPORT_DLL bool MayaExt_ExportHandled(MObject&amp; pMayaObject);\nEXPORT_DLL void MayaExt_ExportBegin(FbxScene* pFbxScene);\nEXPORT_DLL void MayaExt_ExportTranslated(FbxObject* pFbxObject, MObject&amp; pMayaObject);\nEXPORT_DLL void MayaExt_ExportEnd(FbxScene* pFbxScene);\n&nbsp;\nEXPORT_DLL bool MayaExt_ImportHandled(FbxObject* pFbxObject);\nEXPORT_DLL void MayaExt_ImportBegin(FbxScene* pFbxScene);\nEXPORT_DLL void MayaExt_ImportTranslated(FbxObject* pFbxObject, MObject&amp; pMayaObject);\nEXPORT_DLL void MayaExt_ImportEnd(FbxScene* pFbxScene);\n</pre></div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_68ACB4D145F24DEB8E5CBFC8426F97EB\"></a> \n            <h2><a name=\"GUID-FAAECDF0-24F7-4BCC-B791-A8AA070E1B3A\"></a>Running your FBX Extension for Maya\n            </h2> \n            <p><a name=\"GUID-D11369D2-2357-407F-AFC7-370637288D99\"></a>FBX Extensions for Maya must be compiled as dynamic library files (<span class=\"filePath\">.dll</span> for Windows) and placed in the following Maya subdirectory: <a name=\"UL_B8176EAD361E43D28FFA21E3B86C758F\"></a><ul>\n                  <li> <span class=\"filePath\">&lt;maya_install_path&gt;/bin/plug-ins/fbx</span> \n                  </li>\n               </ul> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_08771938F85C44CE817ADD583ED940FA\"></a> \n            <h2><a name=\"GUID-B60809DA-05ED-4AF3-9422-4269098494D2\"></a>Sample Code\n            </h2> \n            <p><a name=\"GUID-EA39AE2B-B91C-42BE-97DD-D94A92B61A28\"></a>The following FBX Extensions SDK subdirectories contain sample Visual Studio projects.\n               \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6BD9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"52.50875145857643%\">\n                     <col width=\"47.49124854142357%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Directory </th>\n                     <th class=\"table-heading\">Description </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"filePath\">plugins/MayaExtensionPlugin_Template/</span> \n                     </td>\n                     <td class=\"table-body\">Skeleton code and comments for Maya. </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"filePath\">plugins/MayaExtensionPlugin_Example/</span> \n                     </td>\n                     <td class=\"table-body\">Fully functional sample extension for Maya. </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";