var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-520D5AE8-D35C-45F2-8C0F-CDC7F2295546\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>FBX Extensions to MotionBuilder</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-520D5AE8-D35C-45F2-8C0F-CDC7F2295546\"></a><div class=\"head\">\n            <h1>FBX Extensions to MotionBuilder</h1>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_D2BE9DC7295043228A9A6954B078B5FF\"></a> \n            <h2><a name=\"GUID-6F991EDF-83F4-46A8-92F6-DABB4C4194BC\"></a>MotionBuilder FBX Extension Interface\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF2566FFD511FDE75E656748B\"></a>FBX Extensions to MotionBuilder can implement any or all of the following functions.\n               Note that the <span class=\"code\">HFBComponent</span> class refers to the <a href=\"http://www.autodesk.com/motionbuilder-sdkdoc-2012-enu\" target=\"_blank\">MotionBuilder 2012 SDK</a>. \n            </p> \n            <div class=\"codeBlock\"><pre>EXPORT_DLL bool MBExt_IsExtension(){return true;}\n\nEXPORT_DLL bool MBExt_ExportHandled( HFBComponent pFBComponent );\nEXPORT_DLL void MBExt_ExportBegin( FbxScene* pFbxScene );\nEXPORT_DLL void MBExt_ExportTranslated( FbxObject* pFbxObject, HFBComponent pFBComponent );\nEXPORT_DLL void MBExt_ExportEnd( FbxScene* pFbxScene );\n\nEXPORT_DLL bool MBExt_ImportHandled( FbxObject* pFbxObject );\nEXPORT_DLL void MBExt_ImportBegin( FbxScene* pFbxScene );\nEXPORT_DLL void MBExt_ImportTranslated( FbxObject* pFbxObject, HFBComponent pFBComponent );\nEXPORT_DLL void MBExt_ImportEnd( FbxScene* pFbxScene );</pre></div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_2CE51930B10140E092CCB1E96B14E943\"></a> \n            <h2><a name=\"GUID-B6106947-D873-4873-922B-831841C47A6B\"></a>Running your FBX Extension for MotionBuilder\n            </h2> \n            <p><a name=\"GUID-D11369D2-2357-407F-AFC7-370637288D99\"></a>FBX Extensions for MotionBuilder must be compiled as dynamic library files (<span class=\"filePath\">.dll</span>) and placed in one of the following MotionBuilder subdirectories, depending on your\n               processor architecture: <a name=\"UL_E79214E0F5EA48A78B86FDACE4EBF8CF\"></a><ul>\n                  <li>32-bit version of MotionBuilder: <span class=\"filePath\">&lt;motionbuilder_path&gt;/bin/win32/plugins/fbx</span> \n                  </li>\n                  <li>64-bit version of MotionBuilder: <span class=\"filePath\">&lt;motionbuilder_install_path&gt;/bin/x64/plugins/fbx</span> \n                  </li>\n               </ul> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_08771938F85C44CE817ADD583ED940FA\"></a> \n            <h2><a name=\"GUID-B60809DA-05ED-4AF3-9422-4269098494D2\"></a>Sample Code\n            </h2> \n            <p><a name=\"GUID-EA39AE2B-B91C-42BE-97DD-D94A92B61A28\"></a>The following FBX Extensions SDK subdirectories contain sample Visual Studio projects.\n               \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6BD9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"52.50875145857643%\">\n                     <col width=\"47.49124854142357%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Directory </th>\n                     <th class=\"table-heading\">Description </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"filePath\">plugins/MotionBuilderExtensionPlugin_Template/</span> \n                     </td>\n                     <td class=\"table-body\">Skeleton code and comments for MotionBuilder. </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"filePath\">plugins/MotionBuilderExtensionPlugin_Example/</span> \n                     </td>\n                     <td class=\"table-body\">Fully functional sample extension for MotionBuilder. </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";