var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-58688B00-09E8-40A3-A601-5709AEBDD559\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>FBX SDK 2011</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-58688B00-09E8-40A3-A601-5709AEBDD559\"></a><div class=\"head\">\n            <h1>FBX SDK 2011</h1>\n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CB7\"></a> \n            <h2><a name=\"GUID-1696EA6A-6F56-4BC5-8722-A223FC77669F\"></a>New Animation System\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CB6\"></a>The FBX animation system has been completely redesigned. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CB5\"></a>Take nodes, take node containers, current takes, and FCurves have all been replaced\n               by animation stacks (<span class=\"code\">KFbxAnimStack</span>), animation layers (<span class=\"code\">KFbxAnimLayer</span>) animation curve nodes (<span class=\"code\">KFbxAnimCurveNode</span>), and animation curves (<span class=\"code\">KFbxAnimCurve</span>). \n            </p> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CB4\"></a>The <em class=\"mild\">animation stack</em> is now the highest-level container for animation. You can think of an animation stack\n               as a stack of <em class=\"mild\">animation layers</em>, e.g., Layer0, Layer1, Layer2, ... etc. An animation stack must contain at least\n               one animation layer (Layer0, also called the base layer). \n            </p> <a name=\"WS73099CC142F48755-191A86AC126720FA35439DF\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F48755-191A86AC126720FA35439E0\"></a>Advantages of the new animation system\n            </p>\n            <ul>\n               <li>Supports blended animation. </li>\n               <li>Allows you to export a scene to an FBX file that contains nothing but animation curves.\n                  You can then import the animation curves into a scene that contains the characters\n                  or other models to be animated. \n               </li>\n            </ul> \n            <p><a name=\"WS1A9193826455F5FF45564F421269B08A8E9-4D8A\"></a>The new animation system is more transparent, more consistent, and easier to learn:\n               \n            </p> <a name=\"WS1A9193826455F5FF45564F421269B08A8E9-4D89\"></a><ul>\n               <li>All the new animation classes are FBX objects (subclasses from <span class=\"code\">KFbxObject</span>), and therefore inherit a rich library of member functions. \n               </li>\n               <li>The data managed by each class are contained in FBX properties (see FBX properties),\n                  which means that you can query, get, and set data using the member functions of <span class=\"code\">KFbxProperty</span> and <span class=\"code\">KFbxTypedProperty</span>. \n               </li>\n               <li>Objects connect to each other with OO and OP connections (see Connections), which\n                  means that you can query objects to determine their relationships to other objects.\n                  \n               </li>\n               <li>Animation curves can now be used in an order-independent way. This was not possible\n                  in the old animation system. \n               </li>\n               <li>Important concepts such as animation stacks and evaluation are encapsulated in classes\n                  (<span class=\"code\">KFbxAnimStack</span> and <span class=\"code\">KFbxAnimEvaluator</span> respectively), rather than scattered among several classes. \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CAA\"></a> \n            <h2><a name=\"GUID-C5898A09-7487-431E-84D2-D52F83771666\"></a>New Evaluation System\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CA9\"></a>All evaluation can be done with functions of class <span class=\"code\">KFbxAnimEvaluator</span>. These functions replace <span class=\"code\">GetGlobalFromCurrentTake()</span> and all its variants. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CA8\"></a>You simply query the scene for its evaluator, and then you can query the evaluator\n               for the global or local positions of any nodes, as well as the value of any property,\n               at the specified time. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CA7\"></a>The evaluation data is now stored in <span class=\"code\">KFbxAnimEvalState</span>, rather than in <span class=\"code\">KFbxNode</span> objects. \n            </p> <a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CA6\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF45564F421269B08A8E9F46\"></a>Advantages of the new evaluation system\n            </p>\n            <ul>\n               <li>Reduces the memory used by <span class=\"code\">KFbxNode</span>. \n               </li>\n               <li>Allows you to re-use animation data. For example, you can evaluate different times\n                  while keeping the evaluation results in buffers that you can manage. \n               </li>\n               <li>You can write your own evaluator by creating a subclass of <span class=\"code\">KFbxAnimEvaluator</span>. That’s what we did for <span class=\"code\">KFbxAnimEvalClassic</span>, FBX SDK’s default evaluator. \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CA2\"></a> \n            <h2><a name=\"GUID-8606F648-6C13-472D-BDB6-31B9DFA5AA5B\"></a>Scripting with Python FBX\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CA1\"></a>Python FBX is a <em class=\"mild\">Python binding</em> for the C++ library of FBX SDK. It allows you to write Python scripts that can use\n               most of the classes and member functions of FBX SDK. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CA0\"></a> \n            <h2><a name=\"GUID-2BA1BE6C-FCBE-4FD3-8BAC-3588BCA0116A\"></a>File Format Version 7.1.\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7C9F\"></a>The default file format for FBX SDK is now 7.1. This new file format permits smaller\n               FBX files and therefore faster loading and saving of FBX files. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7C9E\"></a> \n            <h2><a name=\"GUID-E0BC8E37-5D46-4A77-8D71-9E85C82ED32D\"></a>Instancing\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7C9D\"></a>If a scene has 50 robots, and the robots are all alike, <em class=\"mild\">instancing</em> means that the FBX file needs to store only one set of mesh data for all the robots.\n               \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7C9C\"></a> \n            <h2><a name=\"GUID-8F3AF95E-0E49-48E9-9083-8E55B82CB518\"></a>Levels of Detail for Meshes\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7C9B\"></a>A new class, <span class=\"code\">KFbxLodGroup</span>, allows you to have different versions of a mesh, each with its own level of detail\n               (LOD). \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7C9A\"></a> \n            <h2><a name=\"GUID-B6256302-489B-4EF9-8931-EE7D04874018\"></a>File Referencing\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7C99\"></a>A new class, <span class=\"code\">KFbxReference</span> supports the file referencing feature in Autodesk Maya. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_A32635174CCE429286A2AD475441C5D4\"></a> \n            <h2><a name=\"GUID-96E122D3-B4C8-4BB7-BEB6-C74DC9C3403B\"></a>DLL Distribution\n            </h2> \n            <p>Since version 2011.3 (June 2010), there are both static and dynamic libraries available\n               for the FBX SDK. Versions before 2011.3 are offered as static libraries only. \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";