var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-5D8BFE45-723E-4BD9-846B-E2B2540157C9\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>FBX Objects</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5D8BFE45-723E-4BD9-846B-E2B2540157C9\"></a><div class=\"head\">\n            <h1>FBX Objects</h1>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_0CBE86D19BF240AEA953CCCC2E20BC2E\"></a> \n            <h2><a name=\"GUID-6A6272D6-2E9D-424C-A7D0-9DE80508A588\"></a>FBX Object Creation and Destruction\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-E569A0121D1945C08-308F\"></a>An FBX object is an instance of <span class=\"code\">FbxObject</span>, or any other class derived from <span class=\"code\">FbxObject</span>. An instance of an object is created by invoking its class\' <span class=\"code\">Create()</span> function, along with a reference to the application\'s <span class=\"code\">FbxManager</span> singleton, or a reference to a <span class=\"code\">FbxScene</span> object. \n            </p> \n            <p><a name=\"GUID-57BE532A-5B67-4BB9-81C8-42577550C409\"></a>An object can be explicitly destroyed by invoking its <span class=\"code\">Destroy()</span> member function, or by invoking <span class=\"code\">Destroy()</span> on the <span class=\"code\">FbxManager</span> or <span class=\"code\">FbxScene</span> object used to create it. The <span class=\"code\">FbxManager</span> used to instantiate a <span class=\"code\">FbxObject</span> can be retrieved by calling <span class=\"code\">FbxObject::GetFbxManager()</span>. Observe that in the following code sample, <span class=\"code\">FbxImporter</span> inherits from <span class=\"code\">FbxIO</span>, which inherits from <span class=\"code\">FbxObject</span>. \n            </p> \n            <div class=\"codeBlock\"><pre>// Assume pImporter is an instance of FbxImporter.\nFbxManager* lSdkManager = pImporter-&gt;GetFbxManager();</pre></div> \n            <p><a name=\"GUID-AA1BB059-C16D-4785-AA35-72515DD45EBA\"></a>For more information on object creation and destruction, see <span class=\"char_link\"><a href=\"GUID-B3BF2A41-2262-4706-ABB3-D3C861B3F03B.htm\">Managing memory with the FBX SDK manager</a></span>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_63D34E6A876E4F518C0C13D7BFDB82E5\"></a> \n            <h2><a name=\"GUID-1D2DDF9F-C4FE-4EED-8760-B00B939515A5\"></a>Properties\n            </h2> \n            <p><a name=\"GUID-944CB593-87DC-4B13-8254-27F655C68230\"></a>The FBX SDK uses the <span class=\"code\">FbxProperty</span> class to enforce strongly typed, static and/or dynamic associations of properties\n               to instances of <span class=\"code\">FbxObject</span>. The FBX SDK property model is described in the <span class=\"char_link\"><a href=\"GUID-283ED424-E506-4A29-848F-9EAC8F1C4AF9.htm\">FBX Properties</a></span> topic. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_7BDAF2C99C6244D49D5EC6CAB254480C\"></a> \n            <h2><a name=\"GUID-A4D32651-4DA6-4458-A16E-3BE47EE855F9\"></a>Collections\n            </h2> \n            <p><a name=\"GUID-F7BEC29E-BDA5-431C-AD13-D2342D31FCA9\"></a>Container classes such as, <span class=\"code\">FbxAnimLayer</span>, <span class=\"code\">FbxAnimStack</span>, and <span class=\"code\">FbxScene</span> inherit from the <span class=\"code\">FbxCollection</span> class. This class provides an interface to: <a name=\"UL_E3EB73AA6B124A588FD6566CD38759A7\"></a><ul>\n                  <li>Add members - <span class=\"code\">FbxCollection::AddMember()</span> \n                  </li>\n                  <li>Remove members - <span class=\"code\">FbxCollection::RemoveMember()</span> \n                  </li>\n                  <li>Count members - <span class=\"code\">FbxCollection::GetMemberCount()</span> \n                  </li>\n                  <li>Get a member - <span class=\"code\">FbxCollection::GetMember()</span> \n                  </li>\n                  <li>Search its members - <span class=\"code\">FbxCollection::FindMember()</span> \n                  </li>\n               </ul> \n            </p> \n            <p><a name=\"GUID-DE9557FF-C710-425A-BDC9-B35594F37CBC\"></a> The <span class=\"code\">FbxCollection::GetMemberCount()</span> and <span class=\"code\">FbxCollection::GetMember()</span> functions are overloaded to accept an <span class=\"code\">FbxCriteria</span>. Consult the <span class=\"code\">FbxCriteria</span> class reference page for more information. \n            </p> \n            <p><a name=\"GUID-79F877CF-9549-43FC-B60E-FD5A81996262\"></a> \n               <div><a name=\"GUID-8C6EEFEF-B6E2-4A34-A6E8-36787EA95AFB\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The <span class=\"char_link\"><a href=\"GUID-BB63A93A-7663-4256-B060-8EA35CB0FF3A.htm\">Connections</a></span> topic provides more information on how to navigate between objects and property hierarchies.\n                     \n                  </div>\n               </div> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_C26E7CC296A140CE957F3244795FACDE\"></a> \n            <h2><a name=\"GUID-3664CE27-AF11-418A-920D-E29A07CD04AA\"></a>Copying an FBX Object\n            </h2> \n            <p><a name=\"GUID-EB2A5AEE-5EB6-4437-996F-50637E06944B\"></a>An FBX object can be copied by calling its <span class=\"code\">Copy()</span> member function. The assignment operator (<span class=\"code\">operator=</span>) cannot be used to copy FBX objects; it is a private member function. The following\n               code sample illustrates how to copy a mesh object. \n            </p> \n            <div class=\"codeBlock\"><pre>// Assume that lScene is a pointer to a valid scene object.\nFbxMesh* lSourceMesh = FbxMesh::Create (lScene, \"\");\n&nbsp;\n// Define control points, etc. for lSourceMesh.\n&nbsp;\n// This mesh will be overwritten\nFbxMesh* lTargetMesh = FbxMesh::Create (lScene, \"\");\n&nbsp;\n// Copy the data from lSourceMesh into lTargetMesh. Note that\n// the source object and the target object must be instances of\n// the same class (FbxMesh in this case).\nlTargetMesh-&gt;Copy(lSourceMesh);</pre></div> \n            <p><a name=\"GUID-FAF0D8B2-E9D6-4FA8-954C-92E0935F2D5B\"></a> \n               <div><a name=\"GUID-B6D1AEAF-DC81-4B6A-A8BA-4EAD78A87822\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Copying an <span class=\"code\">FbxObject</span> will <em class=\"strong\">also copy</em> all of its associated <span class=\"code\">FbxProperty</span> instances, and their values. \n                  </div>\n               </div> \n               <div><a name=\"GUID-E30DC517-63D3-4ACB-A119-897ADDF95FC3\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Copying an <span class=\"code\">FbxObject</span> does <em class=\"strong\">not copy</em> any of its inter-object connections (for example, parent-child relationships). These\n                     connections must be set explicitly on the copy. For more information, see <span class=\"char_link\"><a href=\"GUID-BB63A93A-7663-4256-B060-8EA35CB0FF3A.htm\">Connections</a></span>. \n                  </div>\n               </div> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";