var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-6766AFC0-4F25-4436-A5EE-BCDAFC6CB583\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Referencing Media</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6766AFC0-4F25-4436-A5EE-BCDAFC6CB583\"></a><div class=\"head\">\n            <h1>Referencing Media</h1>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_127633C81A374C6B85992E056BB2163A\"></a> \n            <h2><a name=\"GUID-72273E43-4007-4B00-B06D-A3811E976C45\"></a>Referencing Embedded Media\n            </h2> \n            <p><a name=\"GUID-9BC89589-3C5A-4AE7-92B6-E8CD75176496\"></a> When a binary FBX file containing embedded media is imported, the media will be extracted\n               from the file and copied into a subdirectory. This subdirectory will be created at\n               the location of the FBX file with the same name as the file, with the extension <span class=\"code\">.fbm</span>. For example, the embedded media contained in the file <span class=\"code\">&lt;path&gt;\\MyScene.fbx</span> will be extracted into the subdirectory <span class=\"code\">&lt;path&gt;\\MyScene.fbm\\</span>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_C46D1B8C44104D76BFBF82BD358DB737\"></a> \n            <h2><a name=\"GUID-80C2F115-BF9F-4F38-A5AF-2C732464F268\"></a>Referencing Non-Embedded Media\n            </h2> \n            <p><a name=\"GUID-CE84C37B-CD1F-4448-ADDE-C7224E036FFC\"></a>The FBX SDK uses the following steps to locate non-embedded media files for ASCII\n               FBX files, or any other file format which does not contain embedded media. \n            </p> <a name=\"OL_F036C56B3C994BE380413D7E64300EAB\"></a><ol type=\"1\" start=\"1\">\n               <li>It first checks for the existence of the media file at the <em class=\"strong\">absolute path</em> specified by the program which exported the scene to the file. In the following code\n                  sample, the texture\'s filename is specified using <span class=\"code\">FbxFileTexture::SetFileName()</span>. \n                  <div class=\"codeBlock\"><pre>// The resource file is in the application\'s directory.\nFbxString lTexPath = gAppPath + \"\\\\Crate.jpg\";\n\n// Create a texture object.\nFbxFileTexture* lTexture = FbxFileTexture::Create(pScene,\"Crate Texture\");\n\n// Set the texture\'s absolute file path.\nlTexture-&gt;SetFileName(lTexPath.Buffer())</pre></div> \n               </li>\n               <li>If the media file does not exist at the absolute path, the FBX SDK uses the <em class=\"strong\">relative</em> path to the file, which is stored automatically in the FBX file when the scene is\n                  exported. \n               </li>\n            </ol> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";