var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-93C4013B-3C05-447E-AECE-D63D23A87523\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>FBX Extensions to 3ds Max</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-93C4013B-3C05-447E-AECE-D63D23A87523\"></a><div class=\"head\">\n            <h1>FBX Extensions to 3ds Max</h1>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_8B322AA7218E463EA52E4EFBA514ACFC\"></a> \n            <h2><a name=\"GUID-411282D6-F231-4D98-A624-553F3FC44A93\"></a>3ds Max FBX Extension Interface\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF2566FFD511FDE75E656748B\"></a>FBX Extensions to the <em class=\"mild\">FBX Plug-in</em> for 3ds Max can implement any or all of the following functions. Note that the <span class=\"code\">INode</span> class refers to the <a href=\"http://www.autodesk.com/3dsmax-sdkdoc-2012-enu\" target=\"_blank\">3ds Max SDK</a>. \n            </p> \n            <div class=\"codeBlock\"><pre>EXPORT_DLL bool MaxExt_IsExtension(){return true;}\n&nbsp;\nEXPORT_DLL bool MaxExt_ExportHandled(INode* pMaxObject);\nEXPORT_DLL void MaxExt_ExportBegin(FbxScene* pFbxScene, INode* pMaxRootNode);\nEXPORT_DLL void MaxExt_ExportTranslated(FbxObject* pFbxObject, INode* pMaxObject);\nEXPORT_DLL void MaxExt_ExportEnd(FbxScene* pFbxScene, INode* pMaxRootNode);\n&nbsp;\nEXPORT_DLL bool MaxExt_ImportHandled(FbxObject* pFbxObject);\nEXPORT_DLL void MaxExt_ImportBegin(FbxScene* pFbxScene, INode* pMaxRootNode);\nEXPORT_DLL void MaxExt_ImportTranslated(FbxObject* pFbxObject, INode* pMaxObject);\nEXPORT_DLL void MaxExt_ImportEnd(FbxScene* pFbxScene, INode* pMaxRootNode);\n</pre></div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_A8C67F6704414EA59523040221CD1C2E\"></a> \n            <h2><a name=\"GUID-AAEB8334-8864-41F7-A3AF-D5C86B476B12\"></a>Running your FBX Extension for 3ds Max\n            </h2> \n            <p><a name=\"GUID-D11369D2-2357-407F-AFC7-370637288D99\"></a>FBX Extensions for 3ds Max must be compiled as dynamic library files (<span class=\"filePath\">.dll</span>) and placed in the following 3ds Max subdirectory: <a name=\"UL_93D8610EA7EF4AE595450B717DD55392\"></a><ul>\n                  <li> <span class=\"filePath\">&lt;3dsMax_install_path&gt;/stdplugs/fbx</span> \n                  </li>\n               </ul> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_08771938F85C44CE817ADD583ED940FA\"></a> \n            <h2><a name=\"GUID-B60809DA-05ED-4AF3-9422-4269098494D2\"></a>Sample Code\n            </h2> \n            <p><a name=\"GUID-EA39AE2B-B91C-42BE-97DD-D94A92B61A28\"></a>The following FBX Extensions SDK subdirectories contain sample Visual Studio projects.\n               \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6BD9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"52.50875145857643%\">\n                     <col width=\"47.49124854142357%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Directory </th>\n                     <th class=\"table-heading\">Description </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"filePath\">plugins/3dsMaxExtensionPlugin_Template/</span> \n                     </td>\n                     <td class=\"table-body\">Skeleton code and comments for 3ds Max. </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"filePath\">plugins/3dsMaxExtensionPlugin_Example/</span> \n                     </td>\n                     <td class=\"table-body\">Fully functional sample extension for 3ds Max. </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";