var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-A753EE31-7DCF-409E-9270-CD2578FFB633\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>FBX SDK 2013</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A753EE31-7DCF-409E-9270-CD2578FFB633\"></a><div class=\"head\">\n            <h1>FBX SDK 2013</h1>\n         </div>\n         <p><a name=\"GUID-DF11616A-FA93-40DC-995B-E26F776F7514\"></a> The following topic presents the changes made in the 2013 release of the FBX SDK.\n            Consult the <span class=\"code\">readme.txt</span> for additional information, including fixed and known issues. \n         </p>\n         <div class=\"section\"><a name=\"SECTION_A582326D023347E886331359D84722F2\"></a> \n            <h2><a name=\"GUID-73836974-E7F1-4FE5-9ABD-9F8DC200A965\"></a>Refactored API\n            </h2> \n            <p><a name=\"GUID-FB91A8F5-DD5F-4DAE-A60B-0843EBDB1D2F\"></a>The classes in the FBX SDK have all been renamed using the \"<span class=\"code\">Fbx</span>\" prefix, instead of \"<span class=\"code\">KFbx</span>\" or \"<span class=\"code\">K</span>\" or the lower-case \"<span class=\"code\">fbx</span>\". All structures have also been renamed with the same prefix, including global functions\n               and enumerations. For example: \n            </p> <a name=\"UL_EB42A226CDA54BE4912138251D3A6105\"></a><ul>\n               <li><span class=\"code\">KTime</span> and <span class=\"code\">KString</span> have been renamed respectively to <span class=\"code\">FbxTime</span> and <span class=\"code\">FbxString</span>. \n               </li>\n               <li><span class=\"code\">fbxDouble3</span> has been renamed to <span class=\"code\">FbxDouble3</span>. \n               </li>\n               <li>The <span class=\"code\">KFbxSdkManager</span> has been renamed to simply <span class=\"code\">FbxManager</span>. \n               </li>\n            </ul> \n            <p><a name=\"GUID-5597C070-8463-4B3F-9BDE-17FBB866CF49\"></a>By default, the <span class=\"code\">fbxsdk_compatibility.h</span> header file will be included when including <span class=\"code\">fbxsdk.h</span>. This file defines the majority of the old class names to help old applications transition\n               to FBX SDK 2013. However, if you want to exclusively use the new API, you can define\n               <span class=\"code\">FBXSDK_NEW_API</span> in your project. Doing so will exclude the <span class=\"code\">fbxsdk_compatibility.h</span> file, which will most likely result in compilation errors for applications which\n               have been written using previous releases of the FBX SDK. \n            </p> \n            <p><a name=\"GUID-4FAB75C2-C30A-45EC-8C1F-0590F05D17CE\"></a>It is highly recommended that you begin by fixing compilation errors before defining\n               <span class=\"code\">FBXSDK_NEW_API</span> in your project. Given that this compatibility file may be removed in future releases,\n               it is also recommended to fully adapt your code to the latest version of the FBX SDK.\n               \n            </p> \n            <p><a name=\"GUID-2D0A5F90-4498-424E-B58F-15862557C474\"></a>We encourage you to read the information found in <span class=\"code\">fbxsdk_compatibility.h</span> which explains various details about upgrading to this version of FBX. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_F766F181A40F42C3BDE719C289EDC485\"></a> \n            <h2><a name=\"GUID-4AC37384-06BB-4817-BB38-542C1387451B\"></a>Incremented the Supported File Format\n            </h2> <a name=\"UL_6DA4EB23B2644CD697EE1EA04A007B59\"></a><ul>\n               <li>The current FBX file format version has been incremented to <em class=\"strong\">7.3</em>. \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_2B9D674E694349AEB965DBA7E1C8FCF9\"></a> \n            <h2><a name=\"GUID-FCA012D1-E30D-46BA-BEC7-7F64C467F81B\"></a>File Handling\n            </h2> <a name=\"UL_3E2F35E052E64632A5142E7DE425C772\"></a><ul>\n               <li>The <span class=\"code\">FbxFile</span> class has been exposed in <span class=\"code\">fbxfile.h</span>. \n               </li>\n               <li>The <span class=\"code\">FbxFileUtils</span> class now exposes all static functions related to file handling, such as remove,\n                  rename, etc. \n               </li>\n               <li>The <span class=\"code\">FbxPathUtils</span> class now exposes all static functions related to file <em class=\"mild\">path</em> handling, such as <span class=\"code\">IsRelative</span>, <span class=\"code\">Clean</span>, etc. \n               </li>\n               <li>Many FBX SDK functions which required file paths as inputs have been updated to support\n                  UTF-8. The parameter names were updated to reflect this change. \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_3320150A51CA412194DF0BF39EE69EF1\"></a> \n            <h2><a name=\"GUID-11A58FEF-D681-41EB-8F5C-72C8824AA553\"></a>Miscellaneous Changes\n            </h2> <a name=\"UL_BE1CEE2A2A904E2A8CCEF9114876495B\"></a><ul>\n               <li>Removed the <span class=\"code\">KFbxMemoryAllocator</span> class. Instead, use handler setter functions such as <span class=\"code\">FbxSetMallocHandler</span> located in <span class=\"code\">fbxalloc.h</span> \n               </li>\n               <li>Removed all <span class=\"code\">KFCurveFilter</span> classes. Please use <span class=\"code\">FbxAnimCurveFilter</span> instead. \n               </li>\n               <li>Completely re-designed how Character Poses are stored in FBX. </li>\n               <li>The <span class=\"code\">FbxLight</span> class has been augmented to support area lights and barn doors. \n               </li>\n               <li>The <span class=\"code\">FbxGeometryBase</span> class has been augmented to support render options such as <span class=\"code\">PrimaryVisibility</span>, <span class=\"code\">CastShadow</span> and <span class=\"code\">ReceiveShadow</span>. \n               </li>\n               <li>It is now possible to retrieve the \"long\" version string of the FBX SDK via the function\n                  FbxManager::GetVersion(true). This will allow developers to get the version string\n                  of this library along with the name and the revision number. \n               </li>\n               <li>Made multiple functions UTF-8 compatible. </li>\n               <li>The FBX SDK now uses secure versions of CRT calls on the Windows platform. It is now\n                  no longer necessary to disable these warnings when including the FBX SDK headers.\n                  \n               </li>\n               <li>Changed how objects are stored in the manager to increase performance and reduce memory.\n                  \n               </li>\n            </ul> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";