var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-D6A250C3-1014-4FAF-AB0A-5EC21B14A055\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Writing and Using your Own Evaluator</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D6A250C3-1014-4FAF-AB0A-5EC21B14A055\"></a><div class=\"head\">\n            <h1>Writing and Using your Own Evaluator</h1>\n         </div>\n         <p><a name=\"WS73099CC142F4875516078EA312754F1D2D4-7C26\"></a>You can use the <span class=\"code\">FbxAnimEvaluator</span> class to evaluate the animation in a scene. \n         </p>\n         <div class=\"codeBlock\"><pre>\n// Assume that myScene is already created\nFbxAnimEvaluator* mySceneEvaluator = MyScene-&gt;GetEvaluator();\n</pre></div>\n         <p><a name=\"WS73099CC142F4875516078EA312754F1D2D4-7C25\"></a>The <span class=\"code\">FbxAnimEvaluator</span> is an <em class=\"mild\">abstract class</em>. When you call <span class=\"code\">FbxScene::GetEvaluator()</span>, the function creates an instance of a <span class=\"code\">FbxAnimEvalClassic</span> object. The <span class=\"code\">FbxAnimEvalClassic</span> object is the only implementation of the <span class=\"code\">FbxAnimEvaluator</span> class in the current release of FBX SDK. \n         </p>\n         <p><a name=\"WS73099CC142F4875516078EA312754F1D2D4-7C24\"></a>However, you can implement your own evaluator class derived from the <span class=\"code\">FbxAnimEvaluator</span> class. <a name=\"OL_E2CFC453C2EF4B0DA69D5CE8A1D67C74\"></a><p class=\"list-intro\"><a name=\"GUID-4F50B996-1F13-43CC-9608-B068C0D10862\"></a>Perform the following steps to implement your evaluator class:\n            </p>\n            <ol type=\"1\" start=\"1\">\n               <li>Call <span class=\"code\">FbxScene::SetEvaluator()</span> to set the evaluator to your own evaluator object. \n               </li>\n               <li> Make the following call: \n                  <div class=\"codeBlock\"><pre>\nFbxAnimEvaluator* mySceneEvaluator = MyScene-&gt;GetEvaluator();\n</pre></div> \n               </li>\n            </ol> \n         </p>\n         <p><a name=\"WS73099CC142F4875516078EA312754F1D2D4-7C23\"></a>Now, the <span class=\"code\">mySceneEvaluator</span> will point to an object of your own evaluator class. \n         </p>\n         <p><a name=\"GUID-E25196C6-CF61-4F8B-AEB0-F95697C4780C\"></a>See <span class=\"char_link\"><a href=\"GUID-1870771B-1A50-4B8C-B2A0-6979509DE0C1.htm\">Evaluating the Animation in a Scene</a></span> for information on evaluating the animation in a scene. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";