var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2018\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-04-25\">\n      <meta name=\"topicid\" content=\"GUID-E8A5224C-488F-4477-AFE1-FC1EDB6934CB\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Animation Data Structures</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E8A5224C-488F-4477-AFE1-FC1EDB6934CB\"></a><div class=\"head\">\n            <h1>Animation Data Structures</h1>\n         </div>\n         <p><a name=\"GUID-3AB6F1E1-4C67-4DCA-B562-98BE46EDAE47\"></a>The FBX SDK uses these data structures for animation: animation stacks (<span class=\"code\">FbxAnimStack</span>), animation layers (<span class=\"code\">FbxAnimLayer</span>), animation curve nodes (<span class=\"code\">FbxAnimCurveNode</span>), animation curves (<span class=\"code\">FbxAnimCurve</span>), and animation curve keys (<span class=\"code\">FbxAnimCurveKey</span>). The data structures are connected to each other through object-to-object (OO) connections\n            and object-to-property (OP) connections in a FBX scene (<span class=\"code\">FbxScene</span>). See <span class=\"char_link\"><a href=\"GUID-386BAD6A-82F9-4148-BD5F-3FE2E90A87D0.htm\">Animation Classes and their Interrelationships</a></span> for more information about these data structures. \n         </p>\n         <p><a name=\"GUID-34CEC5B8-6FA1-4220-B9B9-02C5B9C35043\"></a>FBX SDK supports blended animation, which is a feature of Autodesk MotionBuilder,\n            Autodesk Maya, and other applications. Blending creates a smooth transition from one\n            animation to another. For example, if you have a set of animation curves that enable\n            a character to walk, and another set that allows the character to run, then you can\n            create a smooth transition from walking to running by blending the walking animation\n            with the running animation. When blending animation, you will get the best results\n            if you blend animation with a similar motion. See <span class=\"char_link\"><a href=\"GUID-9B6410C4-6441-4CAB-BFF5-FE6B07764232.htm\"> Blending Animation</a></span> for a description about using the animation data structures for blending. \n         </p>\n         <p><a name=\"GUID-3E201055-1981-4AAE-A358-55958E25DD3F\"></a>See <span class=\"char_link\"><a href=\"GUID-E5C89F5F-09D1-4C32-BA83-28F63D0B2A6C.htm\">Animating a Node</a></span> for an example on creating animation (unblended) by using these data structures.\n            \n         </p>\n         <p><a name=\"GUID-34FF12A4-CD1B-4374-B6D5-9A8F62013C7A\"></a>Before FBX SDK 2011, the data structures used for animation were the take node, take\n            node container, take info, and others. See <span class=\"char_link\"><a href=\"GUID-3DC64450-58B7-45D6-B7DD-F18190C247DB.htm\">Migrating to the New Data Structures for Animation</a></span> to know the difference between the current data structures and the data structures\n            used for animation in the FBX SDK 2010. \n         </p><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-386BAD6A-82F9-4148-BD5F-3FE2E90A87D0.htm\">Animation Classes and their Interrelationships</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-3DC64450-58B7-45D6-B7DD-F18190C247DB.htm\">Migrating to the New Data Structures for Animation</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-D6A250C3-1014-4FAF-AB0A-5EC21B14A055.htm\">Writing and Using your Own Evaluator</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-92A66661-1A95-4D9F-81CD-6F41B15D2FA6.htm\">Storing Animation in a Vertex Cache</a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";